"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.match.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.object.values.js");

require("core-js/modules/es.string.replace.js");

var _lang = require("../../lang");

var _matchVariable2 = _interopRequireDefault(require("./matchVariable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var evaluateVariableString = function evaluateVariableString(variableString, data) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _matchVariable = (0, _matchVariable2.default)(variableString),
      exact = _matchVariable.exact,
      expression = _matchVariable.expression,
      match = _matchVariable.match;

  if (!match) {
    return variableString;
  }

  var resolvedExpression = evaluateVariableString(expression, data);
  var self = (0, _lang.getProperty)('this', data);
  data = (0, _lang.omit)(['this'], data);
  var params = (0, _lang.concat)((0, _lang.keys)(data), Object.keys(context));
  var args = (0, _lang.concat)((0, _lang.values)(data), Object.values(context));
  var func = new Function(params, "return ".concat(resolvedExpression));
  var value = func.apply(self, args);

  if (!exact) {
    value = variableString.replace(match, value);
  }

  return value;
};

var _default = evaluateVariableString;
exports.default = _default;
//# sourceMappingURL=evaluateVariableString.js.map