"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.match.js");

var _constants = require("../constants");

/**
 * Accepts a string and attempts to find a variable string match
 *
 * @private
 * @function
 * @since v0.3.0
 * @category config.util
 * @param {string} string The string to match
 * @returns {{
 *   expression: string, // the matching variable expression
 *   exact: boolean // whether or not this match was exact
 * }}
 */
var matchVariable = function matchVariable(string) {
  var result = string.match(_constants.Regex.VARIABLE);
  var expression;
  var match;
  var exact;

  if (result) {
    expression = result[1];
    match = result[0];
    exact = result.input === result[0];
  }

  return {
    exact: exact,
    expression: expression,
    match: match
  };
};

var _default = matchVariable;
exports.default = _default;
//# sourceMappingURL=matchVariable.js.map