"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _collection = _interopRequireDefault(require("./collection"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildQuery = (0, _lang.curry)(function (builder, Schema, context, _ref) {
  var cursor = _ref.cursor,
      head = _ref.head,
      includeRemoved = _ref.includeRemoved,
      limit = _ref.limit;
  var query = (0, _collection.default)(Schema, context);
  query = builder(query);

  if (!includeRemoved) {
    query = query.where('removedAt', '==', null);
  }

  if (cursor && cursor !== 'init') {
    if (head) {
      query = query.endAt(cursor);
    } else {
      query = query.startAfter(cursor);
    }
  }

  if (cursor === 'init') {
    query = query.limit(1);
  } else if (limit && !head) {
    query = query.limit(limit);
  }

  return query;
});
var _default = buildQuery;
exports.default = _default;
//# sourceMappingURL=buildQuery.js.map