"use strict";

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.string.includes.js");

var _Code = require("../constants/Code");

var _expected = _interopRequireDefault(require("../error/expected"));

var _lang = require("../lang");

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var isDisconnectError = function isDisconnectError(error) {
  return error.message.includes('ERR_STREAM_WRITE_AFTER_END');
};

var commitBatch = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(batch) {
    var retry,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            retry = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : 0;

            if (!(0, _lang.isPromise)(batch)) {
              _context2.next = 5;
              break;
            }

            _context2.next = 4;
            return batch;

          case 4:
            batch = _context2.sent;

          case 5:
            _context2.prev = 5;
            _context2.next = 8;
            return batch.commit();

          case 8:
            return _context2.abrupt("return", _context2.sent);

          case 11:
            _context2.prev = 11;
            _context2.t0 = _context2["catch"](5);

            if (!isDisconnectError(_context2.t0)) {
              _context2.next = 17;
              break;
            }

            if (!(retry <= 3)) {
              _context2.next = 17;
              break;
            }

            retry = retry + 1;
            return _context2.abrupt("return", (0, _lang.delay)( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      return _context.abrupt("return", commitBatch(batch, retry));

                    case 1:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            })), 1000 * retry));

          case 17:
            if (!(0, _isPermissionsError.default)(_context2.t0)) {
              _context2.next = 19;
              break;
            }

            throw (0, _expected.default)({
              causes: [_context2.t0],
              code: _Code.ACCESS_DENIED,
              message: _context2.t0.message
            });

          case 19:
            throw _context2.t0;

          case 20:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[5, 11]]);
  }));

  return function commitBatch(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _default = commitBatch;
exports.default = _default;
//# sourceMappingURL=commitBatch.js.map