"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("regenerator-runtime/runtime.js");

var _Code = require("../constants/Code");

var _expected = _interopRequireDefault(require("../error/expected"));

var _formatSnapshot = _interopRequireDefault(require("./formatSnapshot"));

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var findAllFromQuery = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref, query) {
    var logger,
        queryOptions,
        snapshot,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            logger = _ref.logger;
            queryOptions = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};

            if (query) {
              _context.next = 4;
              break;
            }

            return _context.abrupt("return", {});

          case 4:
            _context.prev = 4;
            _context.next = 7;
            return query.get();

          case 7:
            snapshot = _context.sent;
            return _context.abrupt("return", (0, _formatSnapshot.default)(snapshot, queryOptions));

          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](4);

            if (!(0, _isPermissionsError.default)(_context.t0)) {
              _context.next = 16;
              break;
            }

            if (process.env.NODE_ENV !== 'production') {
              logger.warn('Permissions error - returning null from query:', _context.t0);
            }

            throw (0, _expected.default)({
              causes: [_context.t0],
              code: _Code.ACCESS_DENIED,
              message: _context.t0.message
            });

          case 16:
            throw _context.t0;

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 11]]);
  }));

  return function findAllFromQuery(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _default = findAllFromQuery;
exports.default = _default;
//# sourceMappingURL=findAllFromQuery.js.map