"use strict";

require("core-js/modules/es.array.find.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _formatDocument = _interopRequireDefault(require("./formatDocument"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formatSnapshotDocuments = function formatSnapshotDocuments(snapshot, options) {
  return (0, _lang.reduce)(function (docs, document) {
    var formatted = (0, _formatDocument.default)(document, options);

    if (!formatted) {
      return docs;
    }

    return (0, _lang.assoc)(document.id, formatted, docs);
  }, {}, snapshot.docs);
};

var formatSnapshot = function formatSnapshot(snapshot) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var document;

  if (snapshot.docs) {
    if (!options.findOne && !options.getOne) {
      return formatSnapshotDocuments(snapshot, options);
    }

    if (options.includeRemoved) {
      document = snapshot.docs[0];
    } else {
      document = (0, _lang.find)(function (doc) {
        return doc.data().removedAt == null;
      }, snapshot.docs);
    }
  } else {
    // QuerySnapshot is actually a DocumentSnapshot
    document = snapshot;
  }

  return (0, _formatDocument.default)(document, options);
};

var _default = formatSnapshot;
exports.default = _default;
//# sourceMappingURL=formatSnapshot.js.map