"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.array.concat.js");

var _lang = require("../lang");

var _collection = _interopRequireDefault(require("./collection"));

var _getSchemaLineage = _interopRequireDefault(require("./getSchemaLineage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (_i = _i.call(arr), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Reference a document by id
 * @function
 * @since v0.5.7
 * @category db
 * @param {Schema} schema
 * @param {Context} context
 * @param {string|Array} ids
 * @returns {DocumentReference}
 */
var refDocumentById = (0, _lang.curry)(function (Schema, context, ids) {
  // accepts an object { ids: [id1, id2] }
  if ((0, _lang.isObject)(ids) && !(0, _lang.isArray)(ids)) {
    ;
    var _ids = ids;
    ids = _ids.ids;
  }

  if ((0, _lang.isNumber)(ids)) {
    ids = ids.toString();
  }

  if ((0, _lang.isString)(ids)) {
    ids = [ids];
  } // accepts a s [id1, id2]


  if (!(0, _lang.isArray)(ids)) {
    throw new TypeError('refDocumentById expects ids to be an Object, a String, a Number or an Array');
  }

  var schemas = (0, _getSchemaLineage.default)(Schema);

  if (schemas.length < ids.length) {
    throw new Error("ids contains too many ids for the given Schema ".concat(Schema.name, " - ids: ").concat(ids));
  } else if (schemas.length > ids.length) {
    throw new Error("ids contains too few ids for the given Schema ".concat(Schema.name, " - ids: ").concat(ids));
  }

  return (0, _lang.reduce)(function (parentRef, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        schema = _ref2[0],
        id = _ref2[1];

    var ParentCollection = (0, _collection.default)(schema, _objectSpread(_objectSpread({}, context), {}, {
      parentRef: parentRef
    }));
    return ParentCollection.doc(id.toString());
  }, context.parentRef, (0, _lang.zip)(schemas, ids));
});
var _default = refDocumentById;
exports.default = _default;
//# sourceMappingURL=refDocumentById.js.map