"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("regenerator-runtime/runtime.js");

var _path = require("../../path");

var _chmod = _interopRequireDefault(require("./chmod"));

var _copyFile = _interopRequireDefault(require("./copyFile"));

var _copyLink = _interopRequireDefault(require("./copyLink"));

var _lstat = _interopRequireDefault(require("./lstat"));

var _mkdir = _interopRequireDefault(require("./mkdir"));

var _readlink = _interopRequireDefault(require("./readlink"));

var _stat = _interopRequireDefault(require("./stat"));

var _symlink = _interopRequireDefault(require("./symlink"));

var _unlink = _interopRequireDefault(require("./unlink"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var mayCopyFile = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(srcStat, src, dest, options) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!options.overwrite) {
              _context.next = 6;
              break;
            }

            _context.next = 3;
            return (0, _unlink.default)(dest);

          case 3:
            return _context.abrupt("return", (0, _copyFile.default)(srcStat, src, dest, options));

          case 6:
            if (!options.errorOnExist) {
              _context.next = 8;
              break;
            }

            throw new Error("'".concat(dest, "' already exists"));

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function mayCopyFile(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var mkDirAndCopy = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(srcMode, src, dest, options, _ref2) {
    var copyDirectory;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            copyDirectory = _ref2.copyDirectory;
            _context2.next = 3;
            return (0, _mkdir.default)(dest);

          case 3:
            _context2.next = 5;
            return copyDirectory(src, dest, options);

          case 5:
            return _context2.abrupt("return", (0, _chmod.default)(dest, srcMode));

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function mkDirAndCopy(_x5, _x6, _x7, _x8, _x9) {
    return _ref3.apply(this, arguments);
  };
}();

var getStats = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(destStat, src, dest, options, _ref4) {
    var copyDirectory, srcStat, resolvedSrc, resolvedDest;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            copyDirectory = _ref4.copyDirectory;

            if (!options.dereference) {
              _context3.next = 7;
              break;
            }

            _context3.next = 4;
            return (0, _stat.default)(src);

          case 4:
            srcStat = _context3.sent;
            _context3.next = 10;
            break;

          case 7:
            _context3.next = 9;
            return _lstat.default;

          case 9:
            srcStat = _context3.sent;

          case 10:
            if (!srcStat.isDirectory()) {
              _context3.next = 18;
              break;
            }

            if (destStat) {
              _context3.next = 13;
              break;
            }

            return _context3.abrupt("return", mkDirAndCopy(srcStat.mode, src, dest, options, {
              copyDirectory: copyDirectory
            }));

          case 13:
            if (!(destStat && !destStat.isDirectory())) {
              _context3.next = 15;
              break;
            }

            throw new Error("Cannot overwrite non-directory '".concat(dest, "' with directory '").concat(src, "'."));

          case 15:
            return _context3.abrupt("return", copyDirectory(src, dest, options));

          case 18:
            if (!(srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())) {
              _context3.next = 24;
              break;
            }

            if (destStat) {
              _context3.next = 21;
              break;
            }

            return _context3.abrupt("return", (0, _copyFile.default)(srcStat, src, dest, options));

          case 21:
            return _context3.abrupt("return", mayCopyFile(srcStat, src, dest, options));

          case 24:
            if (!srcStat.isSymbolicLink()) {
              _context3.next = 48;
              break;
            }

            _context3.next = 27;
            return (0, _readlink.default)(src);

          case 27:
            resolvedSrc = _context3.sent;

            if (options.dereference) {
              resolvedSrc = (0, _path.pathResolve)(process.cwd(), resolvedSrc);
            }

            if (destStat) {
              _context3.next = 31;
              break;
            }

            return _context3.abrupt("return", (0, _symlink.default)(resolvedSrc, dest));

          case 31:
            _context3.prev = 31;
            _context3.next = 34;
            return (0, _readlink.default)(dest);

          case 34:
            resolvedDest = _context3.sent;

            if (options.dereference) {
              resolvedDest = (0, _path.pathResolve)(process.cwd(), resolvedDest);
            }

            if (!(0, _path.isPathSubdir)(resolvedSrc, resolvedDest)) {
              _context3.next = 38;
              break;
            }

            throw new Error("Cannot copy '".concat(resolvedSrc, "' to a subdirectory of itself, '").concat(resolvedDest, "'."));

          case 38:
            if (!(destStat.isDirectory() && (0, _path.isPathSubdir)(resolvedDest, resolvedSrc))) {
              _context3.next = 40;
              break;
            }

            throw new Error("Cannot overwrite '".concat(resolvedDest, "' with '").concat(resolvedSrc, "'."));

          case 40:
            return _context3.abrupt("return", (0, _copyLink.default)(resolvedSrc, dest));

          case 43:
            _context3.prev = 43;
            _context3.t0 = _context3["catch"](31);

            if (!(_context3.t0.code === 'EINVAL' || _context3.t0.code === 'UNKNOWN')) {
              _context3.next = 47;
              break;
            }

            return _context3.abrupt("return", (0, _symlink.default)(resolvedSrc, dest));

          case 47:
            throw _context3.t0;

          case 48:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[31, 43]]);
  }));

  return function getStats(_x10, _x11, _x12, _x13, _x14) {
    return _ref5.apply(this, arguments);
  };
}();

var startCopy = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(destStat, src, dest, options, context) {
    var include;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!options.filter) {
              _context4.next = 6;
              break;
            }

            _context4.next = 3;
            return options.filter(src, dest);

          case 3:
            include = _context4.sent;

            if (include) {
              _context4.next = 6;
              break;
            }

            return _context4.abrupt("return");

          case 6:
            return _context4.abrupt("return", getStats(destStat, src, dest, options, context));

          case 7:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function startCopy(_x15, _x16, _x17, _x18, _x19) {
    return _ref6.apply(this, arguments);
  };
}();

var _default = startCopy;
exports.default = _default;
//# sourceMappingURL=startCopy.js.map