"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.array.from.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _allWith = _interopRequireDefault(require("./allWith"));

var _assocIndex = _interopRequireDefault(require("./assocIndex"));

var _assocKey = _interopRequireDefault(require("./assocKey"));

var _assocProperty = _interopRequireDefault(require("./assocProperty"));

var _curry = _interopRequireDefault(require("./curry"));

var _dispatchable = _interopRequireDefault(require("./dispatchable"));

var _satisfiesIndexed = _interopRequireDefault(require("./satisfiesIndexed"));

var _satisfiesKeyed = _interopRequireDefault(require("./satisfiesKeyed"));

var _satisfiesPropertied = _interopRequireDefault(require("./satisfiesPropertied"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (_i = _i.call(arr), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var baseAssoc = function baseAssoc(selector, value, collection) {
  if ((0, _satisfiesIndexed.default)(collection)) {
    return (0, _assocIndex.default)(selector, value, collection);
  }

  if ((0, _satisfiesKeyed.default)(collection)) {
    return (0, _assocKey.default)(selector, value, collection);
  }

  if ((0, _satisfiesPropertied.default)(collection)) {
    return (0, _assocProperty.default)(selector, value, collection);
  }

  throw new Error("Cannot assoc to the given collection ".concat(collection));
};

var dispatchableAssoc = (0, _dispatchable.default)('assoc', baseAssoc);
/**
 * Makes a shallow clone of an object, setting or overriding the specified property with the given value. Note that this copies and flattens prototype properties onto the new object as well. All non-primitive properties are copied by reference.
 *
 * Supports path based property selectors 'foo.bar' and functional selectors which performs an over on the entire collection and sets each matching selector to the given value.
 *
 * @function
 * @since v0.3.0
 * @category lang
 * @param {Array | String | Function} selector The property path to set or functional selector
 * @param {Any} value The new value
 * @param {Any} collection The collection to clone and assign the new value
 * @returns {Any} A new collection equivalent to the original except for the changed selector path.
 * @example
 *
 * assoc('c', 3, {a: 1, b: 2})          //=> {a: 1, b: 2, c: 3}
 * assoc('c.d', 3, {a: 1, b: 2})        //=> {a: 1, b: 2, c: { d: 3 }}
 * assoc([ 'c', 'd' ], 3, {a: 1, b: 2}) //=> {a: 1, b: 2, c: { d: 3 }}
 */

var assoc = (0, _curry.default)(function (selector, value, collection) {
  return (0, _allWith.default)(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        resolvedSelector = _ref2[0],
        resolvedCollection = _ref2[1];

    return dispatchableAssoc(resolvedSelector, value, resolvedCollection);
  }, [selector, collection]);
});
var _default = assoc;
exports.default = _default;
//# sourceMappingURL=assoc.js.map