"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

var _Symbol = require("../constants/Symbol");

var _anyToImmutableList = _interopRequireDefault(require("../util/anyToImmutableList"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Note: This class is **immutable**
 *
 * This class represents a Path of one or more Propeties, Keys and Indexes
 *
 * @private
 * @class
 * @category lang.classes
 * @since v0.1.0
 */
var Path = /*#__PURE__*/function () {
  function Path(path) {
    _classCallCheck(this, Path);

    this.path = (0, _anyToImmutableList.default)(path);
    this.size = this.path.size;
  }

  _createClass(Path, [{
    key: _Symbol.ITERATOR,
    value: function value() {
      return this.path.values();
    }
  }, {
    key: _Symbol.TO_STRING_TAG,
    get: function get() {
      return 'Path';
    }
  }, {
    key: "first",
    value: function first() {
      return this.get(0);
    }
  }, {
    key: "get",
    value: function get(index) {
      return this.path.get(index);
    }
  }, {
    key: "rest",
    value: function rest() {
      return this.tail();
    }
  }, {
    key: "tail",
    value: function tail() {
      return new Path(this.path.rest());
    }
  }, {
    key: "toName",
    value: function toName() {
      return this.path.join('.');
    }
  }]);

  return Path;
}();

var _default = Path;
exports.default = _default;
//# sourceMappingURL=Path.js.map