"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var RingBuffer = /*#__PURE__*/function () {
  function RingBuffer(overflowHandler) {
    var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10;

    _classCallCheck(this, RingBuffer);

    this.array = new Array(limit);
    this.length = 0;
    this.limit = limit;
    this.overflowHandler = overflowHandler;
    this.pushIndex = 0;
    this.popIndex = 0;
  }

  _createClass(RingBuffer, [{
    key: "flush",
    value: function flush() {
      var items = [];

      while (this.length) {
        items.push(this.take()[0]);
      }

      return items;
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return this.length === 0;
    }
  }, {
    key: "push",
    value: function push(value) {
      this.array[this.pushIndex] = value;
      this.pushIndex = (this.pushIndex + 1) % this.limit;
      this.length++;
    }
  }, {
    key: "setLimit",
    value: function setLimit(limit) {
      this.array = this.flush();
      this.length = this.array.length;
      this.pushIndex = this.array.length;
      this.popIndex = 0;
      this.array.length = limit;
      this.limit = limit;
    }
  }, {
    key: "slide",
    value: function slide(value) {
      this.array[this.pushIndex] = value;
      this.pushIndex = (this.pushIndex + 1) % this.length;
      this.popIndex = this.pushIndex;
    } // TODO BRN: Update this to return a Sequence

  }, {
    key: "take",
    value: function take() {
      var number = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var values = [];

      while (number > 0 && this.length !== 0) {
        var value = this.array[this.popIndex];
        this.array[this.popIndex] = undefined;
        this.length -= 1;
        number -= 1;
        this.popIndex = (this, this.popIndex + 1) % this.limit;
        values.push(value);
      }

      return values;
    }
  }, {
    key: "put",
    value: function put(value) {
      if (this.length < this.limit) {
        return this.push(value);
      } else if (this.overflowHandler) {
        return this.overflowHandler(value, this);
      }

      throw new Error('RingBuffer overflow');
    }
  }]);

  return RingBuffer;
}();

var _default = RingBuffer;
exports.default = _default;
//# sourceMappingURL=RingBuffer.js.map