"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TO_STRING_TAG = exports.ITERATOR = void 0;

var _Symbol2 = _interopRequireDefault(require("../classes/Symbol"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * The `Symbol.iterator` well-known symbol specifies the default iterator for an object. Used by for...of.
 *
 * See [Symbol.iterator](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Symbol/iterator) for more information.
 *
 * @private
 * @type {Symbol}
 * @since v0.1.0
 * @category lang.constants.Symbol
 */
var ITERATOR = typeof _Symbol2.default !== 'undefined' ? _Symbol2.default.iterator : '@@iterator';
/**
 * The `Symbol.toStringTag` well-known symbol is a string valued property that
 * is used in the creation of the default string description of an object. It
 * is accessed internally by the
 * [`Object.prototype.toString()`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toString)
 * method.
 *
 * @private
 * @type {Symbol}
 * @since v0.1.0
 * @category lang.constants.Symbol
 */

exports.ITERATOR = ITERATOR;
var TO_STRING_TAG = _Symbol2.default.toStringTag;
exports.TO_STRING_TAG = TO_STRING_TAG;
//# sourceMappingURL=Symbol.js.map