"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.array.slice.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _any = _interopRequireDefault(require("./any"));

var _classes = require("./classes");

var _containsWildcard2 = _interopRequireDefault(require("./containsWildcard"));

var _findWildcards2 = _interopRequireDefault(require("./findWildcards"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _map = _interopRequireDefault(require("./map"));

var _reduce = _interopRequireDefault(require("./reduce"));

var _replaceWildcards2 = _interopRequireDefault(require("./replaceWildcards"));

var _select2 = _interopRequireDefault(require("./select"));

var _weakMemoize = _interopRequireDefault(require("./weakMemoize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var SELECT_DEFAULT = function SELECT_DEFAULT() {
  throw new Error('select for wildcard selector is currently not implemented');
};

var createSelector = function createSelector(selectors, reducer) {
  if (!(0, _isArray.default)(selectors)) {
    selectors = [selectors];
  }

  var containsWildcard = (0, _weakMemoize.default)(function () {
    return (0, _any.default)(_containsWildcard2.default, selectors);
  });

  var findWildcards = function findWildcards() {
    var wildcards = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _classes.ImmutableMap)({});
    return (0, _reduce.default)(function (accum, selector) {
      return (0, _findWildcards2.default)(selector, accum);
    }, wildcards, selectors);
  };

  var replaceWildcards = function replaceWildcards(wildValues) {
    return createSelector((0, _map.default)((0, _replaceWildcards2.default)(wildValues), selectors), reducer);
  };

  var select;

  if (containsWildcard()) {
    select = SELECT_DEFAULT;
  } else if (reducer) {
    reducer = (0, _weakMemoize.default)(reducer);
    select = (0, _weakMemoize.default)(function (state) {
      var results = (0, _map.default)(function (selector) {
        return (0, _select2.default)(selector, state);
      }, selectors);
      return reducer.apply(void 0, _toConsumableArray(results));
    });
  } else {
    select = (0, _weakMemoize.default)(function (state) {
      var results = (0, _map.default)(function (selector) {
        return (0, _select2.default)(selector, state);
      }, selectors);

      if (results.length === 1) {
        return results[0];
      }

      return results;
    });
  }

  return {
    containsWildcard: containsWildcard,
    findWildcards: findWildcards,
    reducer: reducer,
    replaceWildcards: replaceWildcards,
    select: select,
    selectors: selectors
  };
};

var _default = createSelector;
exports.default = _default;
//# sourceMappingURL=createSelector.js.map