"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

var _invariant = _interopRequireDefault(require("./invariant"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promisfy = function promisfy(func) {
  (0, _invariant.default)((0, _isFunction.default)(func), 'func must be a Function');
  return function () {
    var _this = this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve, reject) {
      args.push(function (err, value) {
        if (err) {
          return reject(err);
        }

        return resolve(value);
      });
      func.apply(_this, args);
    });
  };
};

var _default = promisfy;
exports.default = _default;
//# sourceMappingURL=promisfy.js.map