"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.concat.js");

var _curry = _interopRequireDefault(require("./curry"));

var _getPath = _interopRequireDefault(require("./getPath"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isImmutableList = _interopRequireDefault(require("./isImmutableList"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isSelector = _interopRequireDefault(require("./isSelector"));

var _isString = _interopRequireDefault(require("./isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var select = (0, _curry.default)(function (selector, state) {
  if ((0, _isNil.default)(selector)) {
    return state;
  }

  for (var _len = arguments.length, rest = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    rest[_key - 2] = arguments[_key];
  }

  if ((0, _isFunction.default)(selector)) {
    return selector.apply(void 0, [state].concat(rest));
  }

  if ((0, _isSelector.default)(selector)) {
    return selector.select.apply(selector, [state].concat(rest));
  }

  if ((0, _isArray.default)(selector) || (0, _isImmutableList.default)(selector) || (0, _isString.default)(selector)) {
    return (0, _getPath.default)(selector, state);
  }

  throw new TypeError("unknown selector type ".concat(selector));
});
var _default = select;
exports.default = _default;
//# sourceMappingURL=select.js.map