"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

var _classes = require("../classes");

var _Integer = require("../constants/Integer");

var _Regex = require("../constants/Regex");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 * @example
 *
 * anyIsIndex(0)
 * //=> true
 *
 * anyIsIndex(1)
 * //=> true
 *
 * anyIsIndex(-1)
 * //=> false
 */
var anyIsIndex = function anyIsIndex(any) {
  if (any instanceof _classes.Index) {
    return true;
  } // NOTE BRN: max safe length is exactly MAX_SAFE since the length of an array cannot safely be greater than the max integer.


  var type = _typeof(any);

  return (type === 'number' || type != 'symbol' && _Regex.UINT.test(any)) && any > -1 && any % 1 == 0 && any < _Integer.MAX_SAFE;
};

var _default = anyIsIndex;
exports.default = _default;
//# sourceMappingURL=anyIsIndex.js.map