"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

var _anyIsArray = _interopRequireDefault(require("./anyIsArray"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Checks if `any` is classified as a `String` primitive or object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is a string, else `false`.
 * @example
 *
 * anyIsString('abc')
 * // => true
 *
 * anyIsString(new String('abc'))
 * // => true
 *
 * anyIsString(1)
 * // => false
 */
var anyIsString = function anyIsString(any) {
  var type = _typeof(any);

  return type == 'string' || type == 'object' && any != null && !(0, _anyIsArray.default)(any) && (0, _anyToStringTag.default)(any) == 'String';
};

var _default = anyIsString;
exports.default = _default;
//# sourceMappingURL=anyIsString.js.map