"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.set.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

var _curry = _interopRequireDefault(require("./curry"));

var _isObjectLike = _interopRequireDefault(require("./isObjectLike"));

var _map = _interopRequireDefault(require("./map"));

var _walk = _interopRequireDefault(require("./walk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapWalkee = function mapWalkee() {
  var visited = new Set();
  return function (iteratee, value, recur) {
    if ((0, _isObjectLike.default)(value)) {
      value = (0, _map.default)(iteratee, value);

      if (!visited.has(value)) {
        return (0, _map.default)(function (child) {
          return recur(iteratee, child);
        }, value);
      }
    }

    return value;
  };
};

var walkMap = (0, _curry.default)(function (iteratee, collection) {
  return (0, _walk.default)(mapWalkee(), iteratee, collection);
});
var _default = walkMap;
exports.default = _default;
//# sourceMappingURL=walkMap.js.map