"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

var _constants = require("./constants");

var _pathResolve = _interopRequireDefault(require("./pathResolve"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * return true if `dest` is a subdir of `path`, otherwise false.
 * NOTE: It only checks the path strings.
 *
 * @function
 * @since v0.5.0
 * @category path
 * @param {String} path The path to check
 * @param {String} dest The destination path to compare against
 * @returns {Boolean} returns true if `dest` is a subdir of `path`
 */
var isPathSubdir = function isPathSubdir(path, dest) {
  var pathArr = (0, _pathResolve.default)(path).split(_constants.Path.SEPARATOR).filter(function (i) {
    return i;
  });
  var destArr = (0, _pathResolve.default)(dest).split(_constants.Path.SEPARATOR).filter(function (i) {
    return i;
  });
  return pathArr.reduce(function (acc, cur, i) {
    return acc && destArr[i] === cur;
  }, true);
};

var _default = isPathSubdir;
exports.default = _default;
//# sourceMappingURL=isPathSubdir.js.map