"use strict";

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.for-each.js");

var _ramda = require("ramda");

function toEqualPrintDiff(received, expecteds) {
  var _this = this;

  var options = {
    comment: 'Checks for a value equality between two objects and prints a usable diff',
    isNot: this.isNot,
    promise: this.promise
  };
  var expectedProps = (0, _ramda.keys)(expecteds);
  var foundProps = [];
  expectedProps.forEach(function (expectedProp) {
    var expected = expecteds[expectedProp];
    expect(received).toHaveProperty(expectedProp, expected);
    foundProps.push(expectedProp);
  });
  var remainingProps = (0, _ramda.keys)((0, _ramda.omit)(foundProps, received));
  var pass = remainingProps.length === 0;
  var message = pass ? function () {
    return _this.utils.matcherHint('toHaveReturnedTruthyForValues', undefined, undefined, options) + '\n\n' + "Expected: ".concat(_this.utils.printExpected(expecteds), "\n") + "Received: ".concat(_this.utils.printReceived(received));
  } : function () {
    return _this.utils.matcherHint('toBe', undefined, undefined, options) + '\n\n' + "Expected: ".concat(_this.utils.printExpected(expecteds), "\n") + "Received: ".concat(_this.utils.printReceived(received), "\n") + "Difference: Object contains the following unexpected properties ['".concat(remainingProps.join("', '"), "']");
  };
  return {
    actual: received,
    message: message,
    pass: pass
  };
}

var _default = toEqualPrintDiff;
exports.default = _default;
//# sourceMappingURL=toEqualPrintDiff.js.map