"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function toHaveReturnedFalsyForValues(func, values) {
  var _this = this;

  var options = {
    comment: 'Checks for a return of `false` from multiple values',
    isNot: this.isNot,
    promise: this.promise
  };
  var idx = 0;
  var pass = true;
  var received;
  var value;
  var expected = false;

  while (idx < values.length && pass) {
    value = values[idx];
    received = func(value);
    pass = received === expected;
    idx += 1;
  }

  var message = function message() {
    return _this.utils.matcherHint('toHaveReturnedFalsyForValues', func, "[".concat(value, "]"), options) + '\n\n' + "Expected: ".concat(_this.utils.printExpected(expected), "\n") + "Received: ".concat(_this.utils.printReceived(received));
  };

  return {
    actual: received,
    message: message,
    pass: pass
  };
}

var _default = toHaveReturnedFalsyForValues;
exports.default = _default;
//# sourceMappingURL=toHaveReturnedFalsyForValues.js.map