"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function toThrowMatchingObject(func, expected) {
  var _this = this;

  var options = {
    comment: 'Expects the function to throw an value that matches the given object',
    isNot: this.isNot,
    promise: this.promise
  };
  var pass = true;
  var received;

  try {
    func();
  } catch (thrown) {
    received = thrown;
  }

  if (received) {
    expect(received).toMatchObject(expected);
  } else {
    pass = false;
  }

  var message = pass ? function () {
    return _this.utils.matcherHint('toThrowMatchingObject', undefined, undefined, options) + '\n\n' + "Expected: ".concat(_this.utils.printExpected(expected), "\n") + "Received: ".concat(_this.utils.printReceived(received));
  } : function () {
    return _this.utils.matcherHint('toThrowMatchingObject', undefined, undefined, options) + '\n\n' + "Expected: ".concat(_this.utils.printExpected(expected), "\n") + 'Received function did not throw';
  };
  return {
    actual: received,
    message: message,
    pass: pass
  };
}

var _default = toThrowMatchingObject;
exports.default = _default;
//# sourceMappingURL=toThrowMatchingObject.js.map