"use strict";

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.map.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ramda = require("ramda");

var _classes = require("../../lang/classes");

var valueMap = {
  ImmutableList: (0, _classes.ImmutableList)(),
  ImmutableMap: (0, _classes.ImmutableMap)(),
  ImmutableOrderedMap: (0, _classes.ImmutableOrderedMap)(),
  ImmutableOrderedSet: (0, _classes.ImmutableOrderedSet)(),
  ImmutableSet: (0, _classes.ImmutableSet)(),
  ImmutableStack: (0, _classes.ImmutableStack)(),
  Seq: (0, _classes.Seq)(),
  ['Seq.Indexed']: _classes.Seq.Indexed(),
  ['Seq.Keyed']: _classes.Seq.Keyed(),
  ['Seq.Set']: _classes.Seq.Set()
};

var immutables = function immutables() {
  var selected = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _ramda.keys)(valueMap);
  return (0, _ramda.map)(function (key) {
    return valueMap[key];
  }, selected);
};

var _default = immutables;
exports.default = _default;
//# sourceMappingURL=immutables.js.map